﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DocumentFormat.OpenXml;
using DocumentFormat.OpenXml.Packaging;
using DocumentFormat.OpenXml.Spreadsheet;

namespace ConvertCellsToTable
{
    class Program
    {
        public static void AddTableDefinitionPart(WorksheetPart part)
        {
            TableDefinitionPart tableDefinitionPart1 = part.AddNewPart<TableDefinitionPart>("rId1");
            GenerateTableDefinitionPart1Content(tableDefinitionPart1);
        }

        // Generates content of tableDefinitionPart1.
        private static void GenerateTableDefinitionPart1Content(TableDefinitionPart tableDefinitionPart1)
        {
            Table table1 = new Table() { Id = (UInt32Value)1U, Name = "Table1", DisplayName = "Table1", Reference = "A1:C4", TotalsRowShown = false };
            AutoFilter autoFilter1 = new AutoFilter() { Reference = "A1:C4" };

            TableColumns tableColumns1 = new TableColumns() { Count = (UInt32Value)3U };
            TableColumn tableColumn1 = new TableColumn() { Id = (UInt32Value)1U, Name = "Make" };
            TableColumn tableColumn2 = new TableColumn() { Id = (UInt32Value)2U, Name = "Miles" };
            TableColumn tableColumn3 = new TableColumn() { Id = (UInt32Value)3U, Name = "Cost", DataFormatId = (UInt32Value)0U };

            tableColumns1.Append(tableColumn1);
            tableColumns1.Append(tableColumn2);
            tableColumns1.Append(tableColumn3);
            TableStyleInfo tableStyleInfo1 = new TableStyleInfo() { Name = "TableStyleMedium2", ShowFirstColumn = false, ShowLastColumn = false, ShowRowStripes = true, ShowColumnStripes = false };

            table1.Append(autoFilter1);
            table1.Append(tableColumns1);
            table1.Append(tableStyleInfo1);

            tableDefinitionPart1.Table = table1;
        }

        static void Main(string[] args)
        {
            using (SpreadsheetDocument ssDoc =
                SpreadsheetDocument.Open("Test1.xlsx", true))
            {
                WorksheetPart wsPart = (WorksheetPart)ssDoc.WorkbookPart.GetPartById("rId1");
                AddTableDefinitionPart(wsPart);

                TableParts tableParts1 = new TableParts() { Count = (UInt32Value)1U };
                TablePart tablePart1 = new TablePart() { Id = "rId1" };

                tableParts1.Append(tablePart1);

                wsPart.Worksheet.Append(tableParts1);

                WorkbookStylesPart stylesPart = ssDoc.WorkbookPart.WorkbookStylesPart;
                DifferentialFormats dxfs = stylesPart.RootElement.Descendants<DifferentialFormats>().FirstOrDefault();
                if (dxfs != null)
                {
                    DifferentialFormats differentialFormats1 = new DifferentialFormats() { Count = (UInt32Value)1U };

                    DifferentialFormat differentialFormat1 = new DifferentialFormat();
                    NumberingFormat numberingFormat2 = new NumberingFormat() { NumberFormatId = (UInt32Value)10U, FormatCode = "\"$\"#,##0_);[Red]\\(\"$\"#,##0\\)" };

                    differentialFormat1.Append(numberingFormat2);

                    differentialFormats1.Append(differentialFormat1);
                    TableStyles tableStyles1 = new TableStyles() { Count = (UInt32Value)0U, DefaultTableStyle = "TableStyleMedium2", DefaultPivotStyle = "PivotStyleMedium9" };

                    dxfs.Parent.ReplaceChild(differentialFormats1, dxfs);
                }
            }
        }
    }
}
